Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4411)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4412)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Bugfix: corrected character length in dimension_names
+! 
+! 4411 2020-02-18 14:28:02Z maronga
 ! Added output in NetCDF format using DOM (only netcdf4-parallel is supported).
 ! Old ASCII output is still available at the moment.
@@ -1433,5 +1436,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1444,5 +1447,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1456,5 +1459,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1467,5 +1470,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1478,5 +1481,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1489,5 +1492,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1500,5 +1503,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1511,5 +1514,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1523,5 +1526,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   
@@ -1534,5 +1537,5 @@
        return_value = dom_def_var( nc_filename,                        &
                                    variable_name = variable_name,      &
-                                   dimension_names = (/ 'turbine', 'time' /),     &
+                                   dimension_names = (/ 'turbine', 'time   ' /),     &
                                    output_type = 'real32' )
   