Index: palm/trunk/SCRIPTS/palmrungui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui	(revision 4426)
+++ palm/trunk/SCRIPTS/palmrungui	(revision 4427)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Small fixes and adjustments
+# 
+# 4420 2020-02-24 14:13:56Z maronga
 # Bugfix: minor fixes related to start buttons
 # 
@@ -1154,8 +1157,16 @@
        self.load_jobs()
        self.setEnabled(True)
+       self.update_input()
 
     # Load jobs into list
     def load_jobs(self):
        
+       selected_job = self.list_jobs.currentItem()
+       
+       if ( selected_job is not None ):
+          jobname = selected_job.text()
+       else:
+          jobname = ""
+
        self.list_jobs.clear() 
        self.push_copy.setEnabled(False)
@@ -1173,4 +1184,10 @@
              self.list_jobs.addItem(str(list_of_files[i]))
        
+
+
+       item2int = self.list_jobs.findItems(jobname,QtCore.Qt.MatchCaseSensitive)
+        
+       if ( item2int != [] ):
+          self.list_jobs.setCurrentItem(item2int[0])
 
 
Index: palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui	(revision 4426)
+++ palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui	(revision 4427)
@@ -85,7 +85,7 @@
       <rect>
        <x>150</x>
-       <y>20</y>
+       <y>15</y>
        <width>90</width>
-       <height>21</height>
+       <height>26</height>
       </rect>
      </property>
@@ -101,7 +101,7 @@
       <rect>
        <x>10</x>
-       <y>20</y>
+       <y>15</y>
        <width>131</width>
-       <height>21</height>
+       <height>26</height>
       </rect>
      </property>
@@ -123,7 +123,7 @@
       <rect>
        <x>250</x>
-       <y>20</y>
+       <y>15</y>
        <width>90</width>
-       <height>21</height>
+       <height>26</height>
       </rect>
      </property>
@@ -166,8 +166,8 @@
      <property name="geometry">
       <rect>
-       <x>430</x>
+       <x>470</x>
        <y>20</y>
-       <width>351</width>
-       <height>20</height>
+       <width>311</width>
+       <height>21</height>
       </rect>
      </property>
@@ -179,5 +179,5 @@
      <property name="geometry">
       <rect>
-       <x>340</x>
+       <x>370</x>
        <y>20</y>
        <width>81</width>
@@ -232,8 +232,8 @@
       <property name="geometry">
        <rect>
-        <x>10</x>
-        <y>395</y>
-        <width>431</width>
-        <height>266</height>
+        <x>0</x>
+        <y>375</y>
+        <width>441</width>
+        <height>286</height>
        </rect>
       </property>
@@ -250,7 +250,7 @@
        <property name="geometry">
         <rect>
-         <x>310</x>
-         <y>50</y>
-         <width>111</width>
+         <x>330</x>
+         <y>55</y>
+         <width>101</width>
          <height>21</height>
         </rect>
@@ -266,6 +266,6 @@
        <property name="geometry">
         <rect>
-         <x>230</x>
-         <y>50</y>
+         <x>250</x>
+         <y>55</y>
          <width>71</width>
          <height>21</height>
@@ -282,6 +282,64 @@
        <property name="geometry">
         <rect>
-         <x>100</x>
-         <y>105</y>
+         <x>130</x>
+         <y>120</y>
+         <width>91</width>
+         <height>20</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string/>
+       </property>
+      </widget>
+      <widget class="QLabel" name="label_3">
+       <property name="geometry">
+        <rect>
+         <x>10</x>
+         <y>120</y>
+         <width>111</width>
+         <height>16</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Cores:</string>
+       </property>
+       <property name="alignment">
+        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
+       </property>
+      </widget>
+      <widget class="QLineEdit" name="line_tpn">
+       <property name="geometry">
+        <rect>
+         <x>330</x>
+         <y>120</y>
+         <width>101</width>
+         <height>21</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string/>
+       </property>
+      </widget>
+      <widget class="QLabel" name="label_4">
+       <property name="geometry">
+        <rect>
+         <x>220</x>
+         <y>115</y>
+         <width>101</width>
+         <height>21</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Tasks per node:</string>
+       </property>
+       <property name="alignment">
+        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
+       </property>
+      </widget>
+      <widget class="QLineEdit" name="line_account">
+       <property name="geometry">
+        <rect>
+         <x>330</x>
+         <y>145</y>
          <width>101</width>
          <height>20</height>
@@ -289,12 +347,28 @@
        </property>
        <property name="text">
-        <string>10240</string>
-       </property>
-      </widget>
-      <widget class="QLabel" name="label_3">
-       <property name="geometry">
-        <rect>
-         <x>-20</x>
-         <y>105</y>
+        <string/>
+       </property>
+      </widget>
+      <widget class="QLabel" name="label_5">
+       <property name="geometry">
+        <rect>
+         <x>260</x>
+         <y>145</y>
+         <width>61</width>
+         <height>16</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Account:</string>
+       </property>
+       <property name="alignment">
+        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
+       </property>
+      </widget>
+      <widget class="QLabel" name="label_6">
+       <property name="geometry">
+        <rect>
+         <x>10</x>
+         <y>145</y>
          <width>111</width>
          <height>16</height>
@@ -302,5 +376,5 @@
        </property>
        <property name="text">
-        <string>Cores:</string>
+        <string>Wallclock time (s):</string>
        </property>
        <property name="alignment">
@@ -308,28 +382,31 @@
        </property>
       </widget>
-      <widget class="QLineEdit" name="line_tpn">
-       <property name="geometry">
-        <rect>
-         <x>310</x>
-         <y>105</y>
-         <width>111</width>
-         <height>21</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>100</string>
-       </property>
-      </widget>
-      <widget class="QLabel" name="label_4">
-       <property name="geometry">
-        <rect>
-         <x>200</x>
-         <y>100</y>
-         <width>101</width>
-         <height>21</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Tasks per node:</string>
+      <widget class="QLineEdit" name="line_time">
+       <property name="geometry">
+        <rect>
+         <x>130</x>
+         <y>145</y>
+         <width>91</width>
+         <height>20</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string/>
+       </property>
+      </widget>
+      <widget class="QLabel" name="label_7">
+       <property name="geometry">
+        <rect>
+         <x>30</x>
+         <y>90</y>
+         <width>91</width>
+         <height>16</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Configuration:</string>
+       </property>
+       <property name="scaledContents">
+        <bool>false</bool>
        </property>
        <property name="alignment">
@@ -337,86 +414,9 @@
        </property>
       </widget>
-      <widget class="QLineEdit" name="line_account">
-       <property name="geometry">
-        <rect>
-         <x>310</x>
-         <y>130</y>
-         <width>111</width>
-         <height>20</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string/>
-       </property>
-      </widget>
-      <widget class="QLabel" name="label_5">
-       <property name="geometry">
-        <rect>
-         <x>200</x>
-         <y>130</y>
-         <width>101</width>
-         <height>16</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Project account:</string>
-       </property>
-       <property name="alignment">
-        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
-       </property>
-      </widget>
-      <widget class="QLabel" name="label_6">
-       <property name="geometry">
-        <rect>
-         <x>-10</x>
-         <y>130</y>
-         <width>101</width>
-         <height>16</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Wallclock time:</string>
-       </property>
-       <property name="alignment">
-        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
-       </property>
-      </widget>
-      <widget class="QLineEdit" name="line_time">
-       <property name="geometry">
-        <rect>
-         <x>100</x>
-         <y>130</y>
-         <width>101</width>
-         <height>20</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>432000</string>
-       </property>
-      </widget>
-      <widget class="QLabel" name="label_7">
-       <property name="geometry">
-        <rect>
-         <x>0</x>
-         <y>80</y>
-         <width>91</width>
-         <height>16</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Configuration:</string>
-       </property>
-       <property name="scaledContents">
-        <bool>false</bool>
-       </property>
-       <property name="alignment">
-        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
-       </property>
-      </widget>
       <widget class="Line" name="line">
        <property name="geometry">
         <rect>
          <x>10</x>
-         <y>150</y>
+         <y>165</y>
          <width>411</width>
          <height>20</height>
@@ -431,5 +431,5 @@
         <rect>
          <x>10</x>
-         <y>165</y>
+         <y>180</y>
          <width>121</width>
          <height>23</height>
@@ -444,5 +444,5 @@
         <rect>
          <x>10</x>
-         <y>185</y>
+         <y>200</y>
          <width>281</width>
          <height>23</height>
@@ -457,5 +457,5 @@
         <rect>
          <x>10</x>
-         <y>205</y>
+         <y>220</y>
          <width>261</width>
          <height>23</height>
@@ -492,5 +492,5 @@
         <rect>
          <x>10</x>
-         <y>225</y>
+         <y>240</y>
          <width>261</width>
          <height>21</height>
@@ -505,5 +505,5 @@
         <rect>
          <x>10</x>
-         <y>245</y>
+         <y>260</y>
          <width>261</width>
          <height>21</height>
@@ -523,5 +523,5 @@
          <y>55</y>
          <width>191</width>
-         <height>21</height>
+         <height>26</height>
         </rect>
        </property>
@@ -560,5 +560,5 @@
        <property name="geometry">
         <rect>
-         <x>100</x>
+         <x>110</x>
          <y>20</y>
          <width>321</width>
@@ -586,5 +586,5 @@
         <rect>
          <x>10</x>
-         <y>55</y>
+         <y>60</y>
          <width>41</width>
          <height>16</height>
@@ -604,5 +604,5 @@
        <property name="geometry">
         <rect>
-         <x>0</x>
+         <x>10</x>
          <y>25</y>
          <width>91</width>
@@ -626,27 +626,11 @@
        </property>
       </widget>
-      <widget class="QLabel" name="palm_logo">
+      <widget class="QPushButton" name="button_palmbuild">
        <property name="geometry">
         <rect>
          <x>330</x>
-         <y>180</y>
-         <width>77</width>
-         <height>72</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>TextLabel</string>
-       </property>
-       <property name="scaledContents">
-        <bool>true</bool>
-       </property>
-      </widget>
-      <widget class="QPushButton" name="button_palmbuild">
-       <property name="geometry">
-        <rect>
-         <x>310</x>
-         <y>80</y>
-         <width>111</width>
-         <height>21</height>
+         <y>85</y>
+         <width>101</width>
+         <height>26</height>
         </rect>
        </property>
@@ -658,8 +642,8 @@
        <property name="geometry">
         <rect>
-         <x>100</x>
-         <y>80</y>
-         <width>201</width>
-         <height>21</height>
+         <x>130</x>
+         <y>85</y>
+         <width>191</width>
+         <height>26</height>
         </rect>
        </property>
@@ -679,30 +663,4 @@
       </property>
      </widget>
-     <widget class="QPushButton" name="push_create_set">
-      <property name="geometry">
-       <rect>
-        <x>560</x>
-        <y>630</y>
-        <width>131</width>
-        <height>24</height>
-       </rect>
-      </property>
-      <property name="text">
-       <string>Create set from job</string>
-      </property>
-     </widget>
-     <widget class="QPushButton" name="push_copy">
-      <property name="geometry">
-       <rect>
-        <x>460</x>
-        <y>630</y>
-        <width>91</width>
-        <height>24</height>
-       </rect>
-      </property>
-      <property name="text">
-       <string>Copy job</string>
-      </property>
-     </widget>
      <widget class="QLineEdit" name="line_path">
       <property name="enabled">
@@ -921,12 +879,69 @@
        </property>
       </widget>
+      <widget class="QPushButton" name="push_copy">
+       <property name="geometry">
+        <rect>
+         <x>10</x>
+         <y>625</y>
+         <width>91</width>
+         <height>24</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Copy job</string>
+       </property>
+      </widget>
+      <widget class="QPushButton" name="push_create_set">
+       <property name="geometry">
+        <rect>
+         <x>110</x>
+         <y>625</y>
+         <width>131</width>
+         <height>24</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Create set from job</string>
+       </property>
+      </widget>
+      <widget class="QLabel" name="palm_logo">
+       <property name="geometry">
+        <rect>
+         <x>630</x>
+         <y>5</y>
+         <width>77</width>
+         <height>72</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>TextLabel</string>
+       </property>
+       <property name="scaledContents">
+        <bool>true</bool>
+       </property>
+      </widget>
+      <zorder>list_jobs</zorder>
+      <zorder>list_input</zorder>
+      <zorder>list_user</zorder>
+      <zorder>label_11</zorder>
+      <zorder>label_10</zorder>
+      <zorder>label_12</zorder>
+      <zorder>push_update</zorder>
+      <zorder>list_output</zorder>
+      <zorder>label_14</zorder>
+      <zorder>list_monitoring</zorder>
+      <zorder>label_15</zorder>
+      <zorder>push_copy</zorder>
+      <zorder>push_create_set</zorder>
+      <zorder>palm_logo</zorder>
+      <zorder>palm_logo</zorder>
      </widget>
      <widget class="QGroupBox" name="group_history">
       <property name="geometry">
        <rect>
-        <x>10</x>
+        <x>0</x>
         <y>5</y>
-        <width>431</width>
-        <height>381</height>
+        <width>441</width>
+        <height>371</height>
        </rect>
       </property>
@@ -943,5 +958,5 @@
          <y>50</y>
          <width>411</width>
-         <height>321</height>
+         <height>311</height>
         </rect>
        </property>
@@ -967,6 +982,4 @@
      <zorder>group_execution</zorder>
      <zorder>label_9</zorder>
-     <zorder>push_create_set</zorder>
-     <zorder>push_copy</zorder>
      <zorder>line_path</zorder>
      <zorder>group_history</zorder>