Index: palm/trunk/SCRIPTS/.palm.iofiles
===================================================================
--- palm/trunk/SCRIPTS/.palm.iofiles	(revision 4427)
+++ palm/trunk/SCRIPTS/.palm.iofiles	(revision 4428)
@@ -86,3 +86,3 @@
 #
 #WTM_OUTPUT_DATA*           out:tr   *         $base_data/$run_identifier/MONITORING     _wtm
-DATA_1D_TS_WTM_NETCDF*     out:tr   *         $fast_io_catalog/$run_identifier/OUTPUT   _wtm       nc
+DATA_1D_TS_WTM_NETCDF*     out:tr   *         $base_data/$run_identifier/OUTPUT   _wtm       nc
Index: palm/trunk/SCRIPTS/palmrungui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui	(revision 4427)
+++ palm/trunk/SCRIPTS/palmrungui	(revision 4428)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Bugfix for update button
+# 
+# 4427 2020-02-27 11:29:51Z maronga
 # Small fixes and adjustments
 # 
@@ -1201,54 +1204,58 @@
        self.push_copy.setEnabled(True)
        self.push_create_set.setEnabled(True)
-      
-       job_to_show = job_dir + "/" + self.list_jobs.currentItem().text() + "/INPUT"
-
-       if ( os.path.isdir(job_to_show) ):
-
-          list_of_files = os.listdir(job_to_show)
+       
+       jobitem = self.list_jobs.currentItem()
+       
+       if ( jobitem != None ):
+       
+          job_to_show = job_dir + "/" + jobitem.text() + "/INPUT"
+
+          if ( os.path.isdir(job_to_show) ):
+
+             list_of_files = os.listdir(job_to_show)
          
-          for i in range(0,len(list_of_files)):
-             tmp_file = job_to_show + "/" + list_of_files[i]
-             
-             if ( os.path.isfile(tmp_file) ):
-	        self.list_input.addItem(str(list_of_files[i]))
+             for i in range(0,len(list_of_files)):
+                tmp_file = job_to_show + "/" + list_of_files[i]
+             
+                if ( os.path.isfile(tmp_file) ):
+                   self.list_input.addItem(str(list_of_files[i]))
   
-       job_to_show = job_dir + "/" + self.list_jobs.currentItem().text() + "/USER_CODE"
-       
-       if ( os.path.isdir(job_to_show) ):
+          job_to_show = job_dir + "/" + jobitem.text() + "/USER_CODE"
+       
+          if ( os.path.isdir(job_to_show) ):
           
-          list_of_files = os.listdir(job_to_show)
+             list_of_files = os.listdir(job_to_show)
           
-          for i in range(0,len(list_of_files)):
-             tmp_file = job_to_show + "/" + list_of_files[i]
-
-             if ( os.path.isfile(tmp_file) ):
-	        self.list_user.addItem(str(list_of_files[i]))
-
-       job_to_show = job_dir + "/" + self.list_jobs.currentItem().text() + "/MONITORING"
-       
-       if ( os.path.isdir(job_to_show) ):
+             for i in range(0,len(list_of_files)):
+                tmp_file = job_to_show + "/" + list_of_files[i]
+
+                if ( os.path.isfile(tmp_file) ):
+                   self.list_user.addItem(str(list_of_files[i]))
+
+          job_to_show = job_dir + "/" + jobitem.text() + "/MONITORING"
+       
+          if ( os.path.isdir(job_to_show) ):
           
-          list_of_files = os.listdir(job_to_show)
+             list_of_files = os.listdir(job_to_show)
           
-          for i in range(0,len(list_of_files)):
-             tmp_file = job_to_show + "/" + list_of_files[i]
-
-             if ( os.path.isfile(tmp_file) ):
-	        self.list_monitoring.addItem(str(list_of_files[i]))
-
-       job_to_show = job_dir + "/" + self.list_jobs.currentItem().text() + "/OUTPUT"
-       
-       if ( os.path.isdir(job_to_show) ):
+             for i in range(0,len(list_of_files)):
+                tmp_file = job_to_show + "/" + list_of_files[i]
+
+                if ( os.path.isfile(tmp_file) ):
+                   self.list_monitoring.addItem(str(list_of_files[i]))
+
+          job_to_show = job_dir + "/" + jobitem.text() + "/OUTPUT"
+
+          if ( os.path.isdir(job_to_show) ):
           
-          list_of_files = os.listdir(job_to_show)
+             list_of_files = os.listdir(job_to_show)
           
-          for i in range(0,len(list_of_files)):
-             tmp_file = job_to_show + "/" + list_of_files[i]
-
-             if ( os.path.isfile(tmp_file) ):
-	        self.list_output.addItem(str(list_of_files[i]))
+             for i in range(0,len(list_of_files)):
+                tmp_file = job_to_show + "/" + list_of_files[i]
+
+                if ( os.path.isfile(tmp_file) ):
+                   self.list_output.addItem(str(list_of_files[i]))
   
-       self.group_execution.findChild(QtGui.QLineEdit,"line_jobname").setText(self.list_jobs.currentItem().text())
+          self.group_execution.findChild(QtGui.QLineEdit,"line_jobname").setText(jobitem.text())
        self.group_history.findChild(QtGui.QListWidget,"list_jobname").clearSelection()
 