Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4432)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4433)
@@ -25,19 +25,22 @@
 ! -----------------
 ! $Id$
+! remove warning for newly implemented RANS mode
+!
+! 4370 2020-01-10 14:00:44Z raasch
 ! vector directives added to force vectorization on Intel19 compiler
-! 
+!
 ! 4346 2019-12-18 11:55:56Z motisi
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4177 2019-08-20 14:32:34Z gronemeier
 ! add comment
-! 
+!
 ! 4170 2019-08-19 17:12:31Z gronemeier
 ! - add performance optimizations according to K. Ketelsen
@@ -46,21 +49,21 @@
 ! - bugfix in using l_wall in initialization (consider wall_adjustment_factor)
 ! - always initialize diss and save the dissipation to that array
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 4110 2019-07-22 17:05:21Z suehring
-! pass integer flag array as well as boundary flags to WS scalar advection 
+! pass integer flag array as well as boundary flags to WS scalar advection
 ! routine
-! 
+!
 ! 4109 2019-07-22 17:00:34Z suehring
 ! - Modularize setting of boundary conditions for TKE and dissipation
 ! - Neumann boundary condition for TKE at model top is set also in child domain
-! - Revise setting of Neumann boundary conditions at non-cyclic lateral 
+! - Revise setting of Neumann boundary conditions at non-cyclic lateral
 !   boundaries
-! - Bugfix, set Neumann boundary condition for TKE at vertical wall instead of 
+! - Bugfix, set Neumann boundary condition for TKE at vertical wall instead of
 !   an implicit Dirichlet boundary condition which implied a sink of TKE
 !   at vertical walls
-! 
+!
 ! 4048 2019-06-21 21:00:21Z knoop
 ! write out preprocessor directives; remove tailing whitespaces
@@ -78,5 +81,5 @@
 ! 3684 2019-01-20 20:20:58Z knoop
 ! Remove unused variable simulated_time
-! 
+!
 ! 2696 2017-12-14 17:12:51Z kanani
 ! Initial revision
@@ -161,5 +164,5 @@
     USE statistics,                                                           &
         ONLY:  hom, hom_sum, statistic_regions
-        
+
     USE surface_mod,                                                          &
         ONLY:  bc_h,                                                          &
@@ -312,5 +315,5 @@
     USE pmc_interface,                                                         &
         ONLY : rans_mode_parent
- 
+
     IMPLICIT NONE
 
@@ -325,6 +328,6 @@
 !
 !--    In LES mode, Neumann conditions with de/x_i=0 are assumed at solid walls.
-!--    Note, only TKE is prognostic in this case and dissipation is only 
-!--    a diagnostic quantity. 
+!--    Note, only TKE is prognostic in this case and dissipation is only
+!--    a diagnostic quantity.
        IF ( .NOT. rans_mode )  THEN
 !
@@ -335,5 +338,5 @@
              !$ACC PRESENT(bc_h, e_p)
              DO  m = 1, bc_h(l)%ns
-                i = bc_h(l)%i(m)            
+                i = bc_h(l)%i(m)
                 j = bc_h(l)%j(m)
                 k = bc_h(l)%k(m)
@@ -345,12 +348,12 @@
           DO  l = 0, 3
 !
-!--          Note concerning missing ACC directive for this loop: Even though  
-!--          the data structure bc_v is present, it may not contain any 
-!--          allocated arrays in the flat but also in a topography case, 
-!--          leading to a runtime error. Therefore, omit ACC directives 
-!--          for this loop, in contrast to the bc_h loop. 
+!--          Note concerning missing ACC directive for this loop: Even though
+!--          the data structure bc_v is present, it may not contain any
+!--          allocated arrays in the flat but also in a topography case,
+!--          leading to a runtime error. Therefore, omit ACC directives
+!--          for this loop, in contrast to the bc_h loop.
              !$OMP PARALLEL DO PRIVATE( i, j, k )
              DO  m = 1, bc_v(l)%ns
-                i = bc_v(l)%i(m)        
+                i = bc_v(l)%i(m)
                 j = bc_v(l)%j(m)
                 k = bc_v(l)%k(m)
@@ -427,8 +430,8 @@
 !
 !--    Nesting case: if parent operates in RANS mode and child in LES mode,
-!--    no TKE is transfered. This case, set Neumann conditions at lateral and 
-!--    top child boundaries. 
+!--    no TKE is transfered. This case, set Neumann conditions at lateral and
+!--    top child boundaries.
 !--    If not ( both either in RANS or in LES mode ), TKE boundary condition
-!--    is treated in the nesting. 
+!--    is treated in the nesting.
        If ( child_domain )  THEN
           IF ( rans_mode_parent  .AND.  .NOT. rans_mode )  THEN
@@ -443,7 +446,7 @@
        ENDIF
 !
-!--    At in- and outflow boundaries also set Neumann boundary conditions 
-!--    for the SGS-TKE. An exception is made for the child domain if 
-!--    both parent and child operate in RANS mode. This case no 
+!--    At in- and outflow boundaries also set Neumann boundary conditions
+!--    for the SGS-TKE. An exception is made for the child domain if
+!--    both parent and child operate in RANS mode. This case no
 !--    lateral Neumann boundary conditions will be set but Dirichlet
 !--    conditions will be set in the nesting.
@@ -456,13 +459,13 @@
           IF ( bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
              e_p(:,nyn+1,:) = e_p(:,nyn,:)
-             IF ( rans_tke_e )  diss_p(:,nyn+1,:) = diss_p(:,nyn,:)  
+             IF ( rans_tke_e )  diss_p(:,nyn+1,:) = diss_p(:,nyn,:)
           ENDIF
           IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
              e_p(:,:,nxl-1) = e_p(:,:,nxl)
-             IF ( rans_tke_e )  diss_p(:,nyn+1,:) = diss_p(:,nyn,:)  
+             IF ( rans_tke_e )  diss_p(:,nyn+1,:) = diss_p(:,nyn,:)
           ENDIF
           IF ( bc_dirichlet_r  .OR.  bc_radiation_r )  THEN
              e_p(:,:,nxr+1) = e_p(:,:,nxr)
-             IF ( rans_tke_e )  diss_p(:,nyn+1,:) = diss_p(:,nyn,:) 
+             IF ( rans_tke_e )  diss_p(:,nyn+1,:) = diss_p(:,nyn,:)
           ENDIF
        ENDIF
@@ -470,5 +473,5 @@
 
 !
-!-- Boundary conditions for TKE dissipation rate in RANS mode. 
+!-- Boundary conditions for TKE dissipation rate in RANS mode.
     IF ( rans_tke_e )  THEN
 !
@@ -550,6 +553,6 @@
     ENDIF
 
- END SUBROUTINE tcm_boundary_conds 
- 
+ END SUBROUTINE tcm_boundary_conds
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -607,9 +610,4 @@
           CALL message( 'tcm_check_parameters', 'PA0501', 1, 2, 0, 6, 0 )
        ENDIF
-
-       message_string = 'RANS mode is still in development! ' //               &
-                        '&Not all features of PALM are yet compatible '//      &
-                        'with RANS mode. &Use at own risk!'
-       CALL message( 'tcm_check_parameters', 'PA0502', 0, 1, 0, 6, 0 )
 
     ELSE
@@ -1495,5 +1493,5 @@
                          l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                &
                                               SQRT( 0.25_wp * dx**2 +                  &
-                                             ( zw(k) - zu(k) )**2 ) )                 
+                                             ( zw(k) - zu(k) )**2 ) )
 !
 !--                   xy-distance (horizontal edges)
@@ -4113,6 +4111,6 @@
 !
 !-- Neumann boundary condition for dissipation diss(nzb,:,:) = diss(nzb+1,:,:).
-!-- Note, bc cannot be set in tcm_boundary conditions as the dissipation 
-!-- in LES mode is only a diagnostic quantity. 
+!-- Note, bc cannot be set in tcm_boundary conditions as the dissipation
+!-- in LES mode is only a diagnostic quantity.
     IF ( .NOT. rans_tke_e .AND. ( use_sgs_for_particles  .OR.                  &
          wang_kernel  .OR.  collision_turbulence  ) )  THEN
@@ -4294,6 +4292,6 @@
 !-- For each surface type determine start and end index (in case of elevated
 !-- topography several up/downward facing surfaces may exist.
-!-- Note, bc cannot be set in tcm_boundary conditions as the dissipation 
-!-- in LES mode is only a diagnostic quantity. 
+!-- Note, bc cannot be set in tcm_boundary conditions as the dissipation
+!-- in LES mode is only a diagnostic quantity.
     IF ( .NOT. rans_tke_e .AND.  ( use_sgs_for_particles  .OR.  wang_kernel    &
           .OR.  collision_turbulence ) )  THEN
@@ -4684,5 +4682,5 @@
 !--             @note The following code cannot be transferred to a subroutine
 !--             due to errors when using OpenACC directives. The execution
-!--             crashes reliably if a subroutine is called at this point (the 
+!--             crashes reliably if a subroutine is called at this point (the
 !--             reasong for this behaviour is unknown, however).
                 dvar_dz = atmos_ocean_sign * ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)